import 'package:rec_api_dart/src/entities/account.ent.dart';
import 'package:rec_api_dart/src/entities/entity.base.dart';

import 'campaign.ent.dart';

class AccountCampaign extends Entity {
  final Campaign campaign;
  final Account account;
  final int acumulatedBonus;
  final int spentBonus;

  AccountCampaign({
    String? id,
    String? createdAt,
    String? updatedAt,
    required this.campaign,
    required this.account,
    this.acumulatedBonus = 0,
    this.spentBonus = 0,
  }) : super(id, createdAt, updatedAt);

  @override
  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'created_at': createdAt.toIso8601String(),
      'updated_at': updatedAt.toIso8601String(),
    };
  }

  factory AccountCampaign.fromJson(Map<String, dynamic> json) {
    return AccountCampaign(
      id: '${json['id']}',
      createdAt: json['created'],
      updatedAt: json['updated'],
      campaign: Campaign.fromJson(json['campaign']),
      account: Account.fromJson(json['account']),
      acumulatedBonus: json['acumulated_bonus'] ?? 0,
      spentBonus: json['spent_bonus'] ?? 0,
    );
  }
}
