import 'award.ent.dart';
import '../entity.base.dart';

class AccountAward extends Entity {
  final int score;
  final int level;
  final Award award;

  AccountAward({
    String? id,
    String? createdAt,
    String? updatedAt,
    required this.award,
    required this.score,
    required this.level,
  }) : super(id, createdAt, updatedAt);

  factory AccountAward.fromJson(Map<String, dynamic> json) {
    return AccountAward(
      id: '${json['id']}',
      createdAt: json['created'],
      updatedAt: json['updated'],
      score: json['score'] ?? 0,
      level: json['level'] ?? 0,
      award: Award.fromJson(json['award']),
    );
  }
}
