import '../../enums/award_action.enum.dart';
import '../../enums/award_scope.enum.dart';
import '../entity.base.dart';

class AccountAwardItem extends Entity {
  final int score;
  final int? topicId;
  final int? postId;
  final int? userId;
  final int? category;
  final String accountName;
  final AwardAction action;
  final AwardScope scope;
  // final AccountAward accountAward;
  final int awardId;

  AccountAwardItem({
    String? id,
    String? createdAt,
    String? updatedAt,
    required this.score,
    required this.awardId,
    required this.action,
    required this.scope,
    required this.accountName,
    this.topicId,
    this.postId,
    this.userId,
    this.category,
  }) : super(id, createdAt, updatedAt);

  factory AccountAwardItem.fromJson(Map<String, dynamic> json) {
    return AccountAwardItem(
      id: '${json['id']}',
      createdAt: json['created'],
      updatedAt: json['updated'],
      score: json['score'] ?? 0,
      topicId: json['topic_id'],
      postId: json['post_id'],
      userId: json['user_id'],
      category: json['category'],
      accountName: json['account_name'],
      action: awardActionFromName(json['action']),
      scope: awardScopeFromName(json['scope']),
      awardId: json['award_id'] ?? 0,
    );
  }
}
