import '../entities/account_campaign.ent.dart';
import 'api_list_response.dart';

class AccountCampaignList extends ApiListResponse<AccountCampaign> {
  final num totalAccumulatedBonus;
  final num totalSpentBonus;
  final List<AccountCampaign> items;

  AccountCampaignList({
    super.total = 0,
    this.items = const [],
    this.totalAccumulatedBonus = 0,
    this.totalSpentBonus = 0,
  });

  factory AccountCampaignList.fromJson(
    Map<String, dynamic> json,
  ) {
    return AccountCampaignList(
      items: json['elements'] != null && !json['elements'].isEmpty
          ? List.from(json['elements']).map((el) => AccountCampaign.fromJson(el)).toList()
          : [],
      total: json['total'] ?? 0,
      totalAccumulatedBonus: json['total_accumulated_bonus'] ?? 0,
      totalSpentBonus: json['total_spent_bonus'] ?? 0,
    );
  }
}
